<ng-container *ngIf="selectedTrack != null" >
    <div [ngClass]="trackService.trackHandlerOn ?'track-info-container':'track-info-offline-container'">
        <table class="table table-striped" aria-describedby="Track Info">
            <thead>
                <tr>
                    <th align="left" scope="title">
                        <button *ngIf="displayInfo" class="button" title="X" (click)="changeInfo()">-</button>
                        <button *ngIf="!displayInfo" class="button" title="X" (click)="changeInfo()">O</button>
                        {{selectedTrack.name}} ({{selectedTrack.trackId}}) <button class="button" title="Delete Track" (click)="deleteTrack(selectedTrack.trackId)">Self Destruction</button>
                    </th>
                </tr>
            </thead>
            <tbody>
                <tr *ngIf="displayInfo">
                    <td>
                        <strong>Lat/Lng:</strong>({{ toDegreesMinutesAndSeconds(selectedTrack.latitude)}}{{selectedTrack.latitude >= 0 ? "N" : "S"}},
                    {{ toDegreesMinutesAndSeconds(selectedTrack.longitude)}}{{selectedTrack.longitude >= 0 ? "E" : "W"}})<br>
                            <strong>CoG:</strong>
                            <button *ngIf="displayInfo" class="button" title="Down CoG" (click)="orderCoG(false)">-</button>
                                <font *ngIf="selectedTrack.courseOverGround != selectedTrack.orderedCourseOverGround" color=red> {{selectedTrack.courseOverGround}}&deg; => {{selectedTrack.orderedCourseOverGround}}&deg; </font> 
                                <font *ngIf="selectedTrack.courseOverGround == selectedTrack.orderedCourseOverGround" color=blue> {{selectedTrack.courseOverGround}}&deg; </font> 
                            <button *ngIf="displayInfo" class="button" title="Up SoG" (click)="orderCoG(true)">+</button>
                            <input type="radio" name="deltaCoG" [value]=0.1 checked="checked" [(ngModel)]="deltaCoGValue">0.1&deg;
                            <input type="radio" name="deltaCoG" [value]=1 checked="checked" [(ngModel)]="deltaCoGValue">1&deg;
                            <input type="radio" name="deltaCoG" [value]=10 [(ngModel)]="deltaCoGValue">10&deg;
                        <br>
                        <strong>SoG:</strong> 
                        <button *ngIf="displayInfo" class="button" title="Down CoG" (click)="orderSoG(false)">-</button>
                        <font *ngIf="selectedTrack.speedOverGround != selectedTrack.orderedSpeedOverGround" color=red> {{selectedTrack.speedOverGround}} => {{selectedTrack.orderedSpeedOverGround}} knots</font> 
                        <font *ngIf="selectedTrack.speedOverGround == selectedTrack.orderedSpeedOverGround" color=blue> {{selectedTrack.speedOverGround}} knots</font>
                        <button *ngIf="displayInfo" class="button" title="Up SoG" (click)="orderSoG(true)">+</button>
                        <input type="radio" name="deltaSoG" [value]=0.1 [(ngModel)]="deltaSoGValue">0.1 
                        <input type="radio" name="deltaSoG" [value]=1 [(ngModel)]="deltaSoGValue">1 
                        <input type="radio" name="deltaSoG" [value]=10 [(ngModel)]="deltaSoGValue">10 kn 
                        <br>
                        <strong>Fuel:</strong> {{selectedTrack.fuelInGallons}} Gallons, 
                        <strong>Noise:</strong> {{selectedTrack.dBNoise}} dB <br>
                        <strong>Elapsed Distance:</strong> {{selectedTrack.distanceTravelled?.toFixed(2)}} NM<br>
                        <font *ngIf="selectedTrack.radarStatus">
                            <strong>Radar Status:</strong> {{selectedTrack.radarStatus}}<br>
                            <strong>Radar Antenna Turn Status:</strong> {{selectedTrack.radarAntennaTurnStatus}}<br>
                            <strong>Radar Azimuth:</strong> {{selectedTrack.radarAzimuth}}<br>
                        </font>
                        <strong>Weapons Available:</strong> {{selectedTrack.weaponsAvailable}} 
                        <button class="button" *ngIf="selectedTrack.weaponsAvailable > 0 " title="Launch Weapon" (click)="launchWeapon(selectedTrack.trackId)">Launch Weapon</button><br>
                        <strong>Created On:</strong> {{toformattedReceivedDate(selectedTrack.creationTime)}}<br>
                        <strong>Updated On:</strong> {{toformattedReceivedDate(selectedTrack.updatedTime)}}<br>
                        <button *ngIf="!displaySpecification" class="button" title="Hide Specification" (click)="changeInfoSpecification()">Show Performance & Specification</button>
                        <button *ngIf="displaySpecification" class="button" title="Hide Specification" (click)="changeInfoSpecification()">Hide Performance & Specification</button>
                    </td>
                </tr>
                <tr *ngIf="selectedTrack.specification != null && displayInfo && displaySpecification">
                    <td>
                        <hr>
                        <strong>Performance:</strong><br>
                        <strong>Ideal Cruise Speed:</strong> {{selectedTrack.specification.idealCruiseSpeed.toFixed(2)}} knots<br>
                        <strong>Speed Efficience:</strong> {{100 * selectedTrack.specification.efficienceSpeedFactor.toFixed(4)}}%<br>
                        <strong>Fuel Consumation:</strong> {{selectedTrack.specification.fuelConsumationPerSeconds.toFixed(3)}} Gallons/s<br>
                        <strong>Weight:</strong><br>
                        <strong>Fuel:</strong> {{selectedTrack.specification.fuelWeight.toFixed(3)}} ton, 
                        <strong>Total:</strong> {{selectedTrack.specification.totalWeight.toFixed(3)}} ton
                        <hr>
                        <strong>Tactical Performance:</strong><br>
                        Max Speed Over Ground: {{selectedTrack.specification.maxSpeedOverGround}} knots<br>
                        Acceleration and Maneuver: {{selectedTrack.specification.acceleration}} knots/s and {{selectedTrack.specification.angularAcceleration}}&deg;/s<br>
                        <hr>
                        <strong>Sonar Performance:</strong> <font color="blue">(Blue Sector)<br>
                        Detection Distance Range: {{selectedTrack.specification.sonarDetectionRange.toFixed(0)}} m<br>
                        Detection Azimuth Range: {{selectedTrack.specification.sonarDetectionAzimuthRange}}&deg;
                        </font>
                        <hr>
                        <strong>Radar Performance:</strong><font color="green">(Green Sector)<br>
                        Detection Range/Azimuth: {{selectedTrack.specification.radarDetectionRange}}m in {{selectedTrack.specification.radarDetectionAzimuthRange}}&deg;<br>
                        Antenna Speed and Pulse Power: {{selectedTrack.specification.radarAntennaTurnSpeed}}&deg;/s at {{selectedTrack.specification.radarTransmittedPulsePower}}W<br>
                        Directivity Detection (Gain/Azimuth): {{selectedTrack.specification.directivityDetectionGain}} in {{selectedTrack.specification.directivityDetectionAzimuth}}&deg;
                    </font><hr>
                    <strong>Self Noise Performance:</strong><br>
                    Speed Linear Coefficient: {{selectedTrack.specification.noiseDueSpeedLinearCoefficient.toFixed(5)}} dB/knots<br>
                    Speed Quadratic Coefficient: {{selectedTrack.specification.noiseDueSpeedQuadraticCoefficient.toFixed(5)}} dB/knots^2<br>
                    </td>
                </tr>        
                <tr *ngIf="selectedTrack.specification != null && displayInfo && displaySpecification">
                    <td>
                        <hr>
                        <strong>Specifications:</strong><br>
                        <strong>Weapons Capacity:</strong>  {{selectedTrack.specification.weaponsCapacity}} missiles<br>
                        <strong>Ship Type:</strong> {{selectedTrack.specification.trackType}}<br>
                        <strong>Dimension:</strong> Beam,LOA,Draught: [{{selectedTrack.specification.beam}}x{{selectedTrack.specification.loa}}x{{selectedTrack.specification.draught}}] m<br>
                        <strong>Capacity:</strong><br>
                        Tonage [Net/Gross]: [{{selectedTrack.specification.grossTonnage}} / {{selectedTrack.specification.netTonnage}}] ton<br>
                        Fuel: {{selectedTrack.specification.fuelCapacityInGallons}} gallons<br>
                    </td>
                </tr>
            </tbody>
        </table>
    </div>
</ng-container>

<ng-container *ngIf="selectedAISTrackInfo != null" >
    <div [ngClass]="trackService.trackHandlerOn ?'track-info-container':'track-info-offline-container'">
        <table class="table table-striped" aria-describedby="Track Info">
            <thead>
                <tr>
                    <th align="left" scope="title">
                        <button *ngIf="displayInfo" class="button" title="X" (click)="changeInfo()">-</button>
                        <button *ngIf="!displayInfo" class="button" title="X" (click)="changeInfo()">O</button>
                        <font *ngIf="selectedAISTrackInfo.aisTrack?.shipName">{{selectedAISTrackInfo.aisTrack.shipName}} ({{selectedAISTrackInfo.aisTrack.mmsi}})</font>
                        <font *ngIf="!selectedAISTrackInfo.aisTrack?.shipName">{{selectedAISTrackInfo.aisTrack.mmsi}}</font>
                    </th>
                </tr>
            </thead>
            <tbody>
                <tr *ngIf="displayInfo">
                    <td>
                        <font *ngIf="selectedAISTrackInfo.aisTrack.shipType">
                            <strong>Ship Type: </strong> {{ selectedAISTrackInfo.aisTrack.shipType}}
                            <br>
                        </font>
                        <strong>Last Message Received:</strong><br>&emsp;{{ selectedAISTrackInfo.aisTrack.messageType}}<br>
                        <strong>Messages Received:</strong> {{ selectedAISTrackInfo.aisTrackMessages.length}}
                        <button *ngIf="!displayAISMessagesListInfo" class="button" title="Last Messages" (click)="changeInfoAISMessagesList()">Expand</button>
                        <button *ngIf="displayAISMessagesListInfo" class="button" title="Last Messages" (click)="changeInfoAISMessagesList()">Collapse</button>
                        <br>
                        <font *ngIf="selectedAISTrackInfo?.aisTrack?.latitude != 0 && selectedAISTrackInfo?.aisTrack?.longitude != 0 ">
                        <strong>Lat/Lng:</strong>({{ formatLatitude(selectedAISTrackInfo.aisTrack.latitude)}},{{ formatLongitude(selectedAISTrackInfo.aisTrack.longitude)}})
                        <br>
                        </font>
                        <font *ngIf="selectedAISTrackInfo?.aisTrack?.latitude == 0 && selectedAISTrackInfo?.aisTrack?.longitude == 0 ">
                            <strong>-- Without Position Report: No presence on map!</strong><br>
                            </font>
                        <strong>CoG:</strong>
                        {{selectedAISTrackInfo.aisTrack.courseOverGround}}&deg;
                        <font *ngIf="selectedAISTrackInfo.aisTrack.trueHeading ">
                            <strong>True Heading:</strong>{{ selectedAISTrackInfo.aisTrack.trueHeading}}&deg;
                        </font>
                        <br>
                        <strong>SoG:</strong> 
                        {{selectedAISTrackInfo.aisTrack.speedOverGround}} knots
                        <br>
                        <strong>Created:</strong> {{toformattedReceivedDate(selectedAISTrackInfo.aisTrack.creationTime)}}<br>
                        <strong>Updated:</strong> {{toformattedReceivedDate(selectedAISTrackInfo.aisTrack.updateTime)}}<br>
                        <!--<button *ngIf="!displaySpecification" class="button" title="Show Details" (click)="changeInfoSpecification()">Show Details</button>
                        <button *ngIf="displaySpecification" class="button" title="Hide Details" (click)="changeInfoSpecification()">Hide Details</button>
                    -->
                        <font  *ngIf="selectedAISTrackInfo.aisTrack.applicationSpecificMessage">
                            <strong>applicationSpecificMessage:</strong> Binary Field Ommited <br>
                        </font>
                        <!-- TODO: Decode binaryData-->
                        <font  *ngIf="selectedAISTrackInfo.aisTrack.callsign">
                            <strong>Callsign:</strong> {{selectedAISTrackInfo.aisTrack.callsign}}<br>
                        </font>
                        <font  *ngIf="selectedAISTrackInfo.aisTrack.communicationState">
                            <strong>CommunicationState:</strong> {{selectedAISTrackInfo.aisTrack.communicationState}}<br>
                        </font>
                        <font  *ngIf="selectedAISTrackInfo.aisTrack.dataTerminalReady">
                            <strong>DataTerminalReady:</strong> {{selectedAISTrackInfo.aisTrack.dataTerminalReady}}<br>
                        </font>
                        <font  *ngIf="selectedAISTrackInfo.aisTrack.designatedAreaCode">
                            <strong>DesignatedAreaCode:</strong> {{selectedAISTrackInfo.aisTrack.designatedAreaCode}}<br>
                        </font>
                        <font  *ngIf="selectedAISTrackInfo.aisTrack.destination">
                            <strong>Destination:</strong> {{selectedAISTrackInfo.aisTrack.destination}}<br>
                        </font>
                        <font  *ngIf="selectedAISTrackInfo.aisTrack.destinationMmsi">
                            <strong>Destination MMSI:</strong> {{selectedAISTrackInfo.aisTrack.destinationMmsi}}<br>
                        </font>
                        <font  *ngIf="selectedAISTrackInfo.aisTrack.draught">
                            <strong>Draught:</strong> {{selectedAISTrackInfo.aisTrack.draught}}<br>
                        </font>
                        <font  *ngIf="selectedAISTrackInfo.aisTrack.toBow">
                            <strong>GPS Distance to:</strong> 
                            Bow: {{selectedAISTrackInfo.aisTrack.toBow}}m,
                            Port: {{selectedAISTrackInfo.aisTrack.toPort}}m,
                            Starboard: {{selectedAISTrackInfo.aisTrack.toStarboard}}m,
                            Stern: {{selectedAISTrackInfo.aisTrack.toStern}}m
                            <br>
                        </font>
                        <font  *ngIf="selectedAISTrackInfo.aisTrack.etaDay">
                            <strong>ETA:</strong> {{selectedAISTrackInfo.aisTrack.etaMonth}} months,
                            {{selectedAISTrackInfo.aisTrack.etaDay}} days,
                            {{selectedAISTrackInfo.aisTrack.etaHour}} hrs,  
                            {{selectedAISTrackInfo.aisTrack.etaMinute}} mins,  
                            <br>
                        </font>
                        <font  *ngIf="selectedAISTrackInfo.aisTrack.functionalId">
                            <strong>Functional Id:</strong> {{selectedAISTrackInfo.aisTrack.functionalId}}<br>
                        </font>
                        <font  *ngIf="selectedAISTrackInfo.aisTrack.imo">
                            <!-- //TODO: Convert IMO -->
                            <strong>Imo:</strong> {{selectedAISTrackInfo.aisTrack.imo}}<br>
                        </font>
                        <font  *ngIf="selectedAISTrackInfo.aisTrack.navigationStatus">
                            <strong>Navigation Status:</strong> {{selectedAISTrackInfo.aisTrack.navigationStatus}}<br>
                        </font>
                        <font  *ngIf="selectedAISTrackInfo.aisTrack.positionAccuracy">
                            <strong>Position Accuracy:</strong> {{selectedAISTrackInfo.aisTrack.positionAccuracy}}<br>
                        </font>
                        <font  *ngIf="selectedAISTrackInfo.aisTrack.positionFixingDevice">
                            <strong>Position Fixing Device:</strong> {{selectedAISTrackInfo.aisTrack.positionFixingDevice}}<br>
                        </font>
                        <font  *ngIf="selectedAISTrackInfo.aisTrack.raimFlag">
                            <strong>Raim Flag:</strong> {{selectedAISTrackInfo.aisTrack.raimFlag}}<br>
                        </font>
                        <font  *ngIf="selectedAISTrackInfo.aisTrack.rateOfTurn">
                            <strong>Rate Of Turn:</strong> {{selectedAISTrackInfo.aisTrack.rateOfTurn}}<br>
                        </font>
                        <font  *ngIf="selectedAISTrackInfo.aisTrack.repeatIndicator">
                            <strong>Repeat Indicator:</strong> {{selectedAISTrackInfo.aisTrack.repeatIndicator}}<br>
                        </font>
                        <font  *ngIf="selectedAISTrackInfo.aisTrack.retransmit">
                            <strong>Retransmit:</strong> {{selectedAISTrackInfo.aisTrack.retransmit}}<br>
                        </font>
                        <font  *ngIf="selectedAISTrackInfo.aisTrack.second">
                            <strong>Second:</strong> {{selectedAISTrackInfo.aisTrack.second}}<br>
                        </font>
                        <font  *ngIf="selectedAISTrackInfo.aisTrack.sequenceNumber">
                            <strong>Sequence Number:</strong> {{selectedAISTrackInfo.aisTrack.sequenceNumber}}<br>
                        </font>
                        <font  *ngIf="selectedAISTrackInfo.aisTrack.spare">
                            <strong>Spare:</strong> {{selectedAISTrackInfo.aisTrack.spare}}<br>
                        </font> 
                        <font  *ngIf="selectedAISTrackInfo.aisTrack.specialManeuverIndicator">
                            <strong>Special Maneuver Indicator:</strong> {{selectedAISTrackInfo.aisTrack.specialManeuverIndicator}}<br>
                        </font>                          
                    </td>
                </tr>        
            </tbody>
        </table>
        <div *ngIf="displayAISMessagesListInfo" [ngClass]="trackService.trackHandlerOn ?'track-aismsginfo-container':'track-aismsginfo-offline-container'">
            <table class="table table-striped" aria-describedby="AISMessages Info">
                <tbody>
                    <tr><th scope="messages">Last Mesages:</th></tr>
                    <tr *ngFor="let message of selectedAISTrackInfo?.aisTrackMessages; let index=index;">
                       <td (click)="showAISMessageSelected(selectedAISTrackInfo.aisTrackMessages[index])">[{{toformattedReceivedDate(message.creationTime)}}] {{message.messageType}}</td>
                    </tr>
                </tbody>
            </table>
        </div>
        <!-- //TODO: Implement Display specific AISMessages (Need cast to specific AISMessage child classes)
        <div *ngIf="displayAISMessagesListInfo && displayAISMessageSelected && aisMessageSelected" [ngClass]="trackService.trackHandlerOn ?'track-aismsginfo-container':'track-aismsginfo-offline-container'">
            <table class="table table-striped">
                <tbody>
                    <tr>
                       <td>[{{toformattedReceivedDate(aisMessageSelected.creationTime)}}] {{aisMessageSelected.messageType}}</td>
                    </tr>
                </tbody>
                <tr>
                    <td>
                        <font *ngIf="aisMessageSelected.hasAttribute('shipType') && aisMessageSelected.shipType">
                            <strong>Ship Type: </strong> {{ aisMessageSelected.shipType}}
                            <br>
                        </font>
                        <br>
                        <font *ngIf="aisMessageSelected.latitude != 0 && aisMessageSelected.longitude != 0 ">
                        <strong>Lat/Lng:</strong>({{ formatLatitude(aisMessageSelected.latitude)}},{{ formatLongitude(aisMessageSelected.longitude)}})
                        <br>
                        </font>
                        <font *ngIf="aisMessageSelected.courseOverGround ">
                        <strong>CoG:</strong>
                        {{aisMessageSelected.courseOverGround}}&deg;
                        </font>
                        <br>
                        <font *ngIf="aisMessageSelected.trueHeading ">
                            <strong>True Heading:</strong>{{ aisMessageSelected.trueHeading}}}&deg;
                            <br>
                        </font>
                        <font *ngIf="aisMessageSelected.speedOverGround ">
                        <strong>SoG:</strong> 
                        {{aisMessageSelected.speedOverGround}} knots<br>
                        </font>
                        <font  *ngIf="aisMessageSelected.applicationSpecificMessage">
                            <strong>applicationSpecificMessage:</strong> Binary Field Ommited <br>
                        </font>
                        <font  *ngIf="aisMessageSelected.callsign">
                            <strong>Callsign:</strong> {{aisMessageSelected.callsign}}<br>
                        </font>
                        <font  *ngIf="aisMessageSelected.communicationState">
                            <strong>CommunicationState:</strong> {{aisMessageSelected.communicationState}}<br>
                        </font>
                        <font  *ngIf="aisMessageSelected.dataTerminalReady">
                            <strong>DataTerminalReady:</strong> {{aisMessageSelected.dataTerminalReady}}<br>
                        </font>
                        <font  *ngIf="aisMessageSelected.designatedAreaCode">
                            <strong>DesignatedAreaCode:</strong> {{aisMessageSelected.designatedAreaCode}}<br>
                        </font>
                        <font  *ngIf="aisMessageSelected.destination">
                            <strong>Destination:</strong> {{aisMessageSelected.destination}}<br>
                        </font>
                        <font  *ngIf="aisMessageSelected.destinationMmsi">
                            <strong>Destination MMSI:</strong> {{aisMessageSelected.destinationMmsi}}<br>
                        </font>
                        <font  *ngIf="aisMessageSelected.draught">
                            <strong>Draught:</strong> {{aisMessageSelected.draught}}<br>
                        </font>
                        <font  *ngIf="aisMessageSelected.toBow">
                            <strong>GPS Distance to:</strong> 
                            Bow: {{aisMessageSelected.toBow}}m,
                            Port: {{aisMessageSelected.toPort}}m,
                            Starboard: {{aisMessageSelected.toStarboard}}m,
                            Stern: {{aisMessageSelected.toStern}}m
                            <br>
                        </font>
                        <font  *ngIf="aisMessageSelected.etaDay">
                            <strong>ETA:</strong> {{aisMessageSelected.etaMonth}} months,
                            {{aisMessageSelected.etaDay}} days,
                            {{aisMessageSelected.etaHour}} hrs,  
                            {{aisMessageSelected.etaMinute}} mins,  
                            <br>
                        </font>
                        <font  *ngIf="aisMessageSelected.functionalId">
                            <strong>Functional Id:</strong> {{aisMessageSelected.functionalId}}<br>
                        </font>
                        <font  *ngIf="aisMessageSelected.imo">
                            <strong>Imo:</strong> {{aisMessageSelected.imo}}<br>
                        </font>
                        <font  *ngIf="aisMessageSelected.navigationStatus">
                            <strong>Navigation Status:</strong> {{aisMessageSelected.navigationStatus}}<br>
                        </font>
                        <font  *ngIf="aisMessageSelected.positionAccuracy">
                            <strong>Position Accuracy:</strong> {{aisMessageSelected.positionAccuracy}}<br>
                        </font>
                        <font  *ngIf="aisMessageSelected.positionFixingDevice">
                            <strong>Position Fixing Device:</strong> {{aisMessageSelected.positionFixingDevice}}<br>
                        </font>
                        <font  *ngIf="aisMessageSelected.raimFlag">
                            <strong>Raim Flag:</strong> {{aisMessageSelected.raimFlag}}<br>
                        </font>
                        <font  *ngIf="aisMessageSelected.rateOfTurn">
                            <strong>Rate Of Turn:</strong> {{aisMessageSelected.rateOfTurn}}<br>
                        </font>
                        <font  *ngIf="aisMessageSelected.repeatIndicator">
                            <strong>Repeat Indicator:</strong> {{aisMessageSelected.repeatIndicator}}<br>
                        </font>
                        <font  *ngIf="aisMessageSelected.retransmit">
                            <strong>Retransmit:</strong> {{aisMessageSelected.retransmit}}<br>
                        </font>
                        <font  *ngIf="aisMessageSelected.second">
                            <strong>Second:</strong> {{aisMessageSelected.second}}<br>
                        </font>
                        <font  *ngIf="aisMessageSelected.sequenceNumber">
                            <strong>Sequence Number:</strong> {{aisMessageSelected.sequenceNumber}}<br>
                        </font>
                        <font  *ngIf="aisMessageSelected.spare">
                            <strong>Spare:</strong> {{aisMessageSelected.spare}}<br>
                        </font> 
                        <font  *ngIf="aisMessageSelected.specialManeuverIndicator">
                            <strong>Special Maneuver Indicator:</strong> {{aisMessageSelected.specialManeuverIndicator}}<br>
                        </font>                          
                        <hr>
                    </td>
                </tr>  
            //
            </table>
        </div>
    -->
    </div>
</ng-container>

